igeo

## Class IBrep

- java.lang.Object
- - igeo.IObject
  - - igeo.IGeometry
    - - igeo.IBrep

- All Implemented Interfaces:
    ITransformable
  Direct Known Subclasses:
    IBox

      public class IBrep
      extends IGeometry
      implements ITransformable

  Class BRep (Boundary Representation) of IObject. Implementation of BRep is not complete yet. To be completed later.
  Author:
    Satoru Sugihara

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `boolean` | `solid` seams defines connection of surfaces (?)
    `ISurfaceGeo[]` | `surfaces`

    - ### Fields inherited from class igeo.IObject

      `attribute, dynamics, graphics, parameter, server, userData`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IBrep(IBrep brep)`
    `IBrep(ICurveI[] outlines)`
    `IBrep(ICurveI[] outlines, ICurveI[][] holes)`
    `IBrep(IServerI s, IBrep brep)`
    `IBrep(IServerI s, ICurveI[] outlines)`
    `IBrep(IServerI s, ICurveI[] outlines, ICurveI[][] holes)`
    `IBrep(IServerI s, ISurface[] srfs)`
    `IBrep(IServerI s, ISurfaceGeo[] srfs)`
    `IBrep(IServerI s, IVecI[][] outlinePoints)`
    `IBrep(ISurface[] srfs)`
    `IBrep(ISurfaceGeo[] srfs)`
    `IBrep(IVecI[][] outlinePoints)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `IBrep` | `add(double x, double y, double z)` implementation of ITransformable interface
    `IBrep` | `add(double f, IVecI v)` scale add alias
    `IBrep` | `add(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBrep` | `add(IDoubleI f, IVecI v)` scale add alias
    `IBrep` | `add(IVecI v)`
    `IBrep` | `add(IVecI v, double f)` scale add
    `IBrep` | `add(IVecI v, IDoubleI f)` scale add
    `IBrep` | `attr(IAttribute at)` set attributes
    `IVecI` | `center()` calculate center by taking average of centers of all surfaces
    `void` | `checkDuplicatedPoints()`
    `IBrep` | `clr(java.awt.Color c)`
    `IBrep` | `clr(java.awt.Color c, double alpha)`
    `IBrep` | `clr(java.awt.Color c, float alpha)`
    `IBrep` | `clr(java.awt.Color c, int alpha)`
    `IBrep` | `clr(double dgray)`
    `IBrep` | `clr(double dgray, double dalpha)`
    `IBrep` | `clr(double dr, double dg, double db)`
    `IBrep` | `clr(double dr, double dg, double db, double da)`
    `IBrep` | `clr(float fgray)`
    `IBrep` | `clr(float fgray, float falpha)`
    `IBrep` | `clr(float fr, float fg, float fb)`
    `IBrep` | `clr(float fr, float fg, float fb, float fa)`
    `IBrep` | `clr(IColor c)` to set an object color
    `IBrep` | `clr(IColor c, double alpha)` to set color, with alpha value overwritten
    `IBrep` | `clr(IColor c, float alpha)` to set color, with alpha value overwritten
    `IBrep` | `clr(IColor c, int alpha)` to set color, with alpha value overwritten
    `IBrep` | `clr(int gray)`
    `IBrep` | `clr(int gray, int alpha)`
    `IBrep` | `clr(int r, int g, int b)`
    `IBrep` | `clr(int r, int g, int b, int a)`
    `IBrep` | `clr(IObject o)` to set the same color with the object
    `IBrep` | `cp()` cp() is alias of dup()
    `IBrep` | `cp(double x, double y, double z)` cp() is alias of dup().add()
    `IBrep` | `cp(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBrep` | `cp(IVecI v)`
    `IGraphicObject` | `createGraphic(IGraphicMode m)`
    `IBrep` | `div(double v)`
    `IBrep` | `div(IDoubleI v)`
    `IBrep` | `dup()` duplicate object
    `IBrep` | `flip()` alias of neg
    `IBrep` | `hide()`
    `IBrep` | `hsb(double h, double s, double b)`
    `IBrep` | `hsb(double h, double s, double b, double a)`
    `IBrep` | `hsb(float h, float s, float b)`
    `IBrep` | `hsb(float h, float s, float b, float a)`
    `void` | `initBrep(IServerI s)`
    `void` | `initBrepWithCurve(IServerI s, ICurveI[] outlines, ICurveI[][] holes)`
    `void` | `initBrepWithPoint(IServerI s, IVecI[][] points)`
    `void` | `initBrepWithSurface(IServerI s, ISurface[] srfs)`
    `void` | `initBrepWithSurfaceGeo(IServerI s, ISurfaceGeo[] srfs)`
    `boolean` | `isValid()` checking parameters validity.
    `IBrep` | `layer(ILayer l)` Set layer by ILayer object
    `IBrep` | `layer(java.lang.String l)` Set layer by layer name.
    `IBrep` | `mirror(IVecI planeDir)` mirror is alias of ref
    `IBrep` | `mirror(IVecI center, IVecI planeDir)`
    `IBrep` | `mul(double v)`
    `IBrep` | `mul(IDoubleI v)`
    `IBrep` | `mv(double x, double y, double z)` mv() is alias of add()
    `IBrep` | `mv(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBrep` | `mv(IVecI v)`
    `IBrep` | `name(java.lang.String nm)`
    `IBrep` | `neg()`
    `IBrep` | `ref(IVecI planeDir)` reflect(mirror) 3 dimensionally to the other side of the plane
    `IBrep` | `ref(IVecI center, IVecI planeDir)`
    `IBrep` | `rot(double angle)`
    `IBrep` | `rot(IDoubleI angle)` rotation around z-axis and origin
    `IBrep` | `rot(IVecI axis, double angle)`
    `IBrep` | `rot(IVecI axis, IDoubleI angle)` rotation around axis vector
    `IBrep` | `rot(IVecI axis, IVecI destDir)` rotate to destination direction vector
    `IBrep` | `rot(IVecI center, IVecI axis, double angle)`
    `IBrep` | `rot(IVecI center, IVecI axis, IDoubleI angle)` rotation around axis vector and center
    `IBrep` | `rot(IVecI center, IVecI axis, IVecI destPt)` rotate to destination point location
    `IBrep` | `rot2(double angle)` rotation on xy-plane around origin; same with rot(double)
    `IBrep` | `rot2(IDoubleI angle)` rotation on xy-plane around origin; same with rot(IDoubleI)
    `IBrep` | `rot2(IVecI destDir)` rotation on xy-plane to destination direction vector
    `IBrep` | `rot2(IVecI center, double angle)`
    `IBrep` | `rot2(IVecI center, IDoubleI angle)` rotation on xy-plane around center
    `IBrep` | `rot2(IVecI center, IVecI destPt)` rotation on xy-plane to destination point location
    `IBrep` | `scale(double f)`
    `IBrep` | `scale(IDoubleI f)` alias of mul
    `IBrep` | `scale(IVecI center, double f)`
    `IBrep` | `scale(IVecI center, IDoubleI f)`
    `IBrep` | `scale1d(IVecI axis, double f)` scale only in 1 direction
    `IBrep` | `scale1d(IVecI axis, IDoubleI f)`
    `IBrep` | `scale1d(IVecI center, IVecI axis, double f)`
    `IBrep` | `scale1d(IVecI center, IVecI axis, IDoubleI f)`
    `IBrep` | `setColor(java.awt.Color c)`
    `IBrep` | `setColor(java.awt.Color c, double alpha)`
    `IBrep` | `setColor(java.awt.Color c, float alpha)`
    `IBrep` | `setColor(java.awt.Color c, int alpha)`
    `IBrep` | `setColor(double dgray)`
    `IBrep` | `setColor(double dgray, double dalpha)`
    `IBrep` | `setColor(double dr, double dg, double db)`
    `IBrep` | `setColor(double dr, double dg, double db, double da)`
    `IBrep` | `setColor(float fgray)`
    `IBrep` | `setColor(float fr, float fg, float fb)`
    `IBrep` | `setColor(float fr, float fg, float fb, float fa)`
    `IBrep` | `setColor(float fgray, int falpha)`
    `IBrep` | `setColor(IColor c)`
    `IBrep` | `setColor(IColor c, double alpha)`
    `IBrep` | `setColor(IColor c, float alpha)`
    `IBrep` | `setColor(IColor c, int alpha)`
    `IBrep` | `setColor(int gray)`
    `IBrep` | `setColor(int gray, int alpha)`
    `IBrep` | `setColor(int r, int g, int b)`
    `IBrep` | `setColor(int r, int g, int b, int a)`
    `IBrep` | `setHSBColor(double h, double s, double b)`
    `IBrep` | `setHSBColor(double h, double s, double b, double a)`
    `IBrep` | `setHSBColor(float h, float s, float b)`
    `IBrep` | `setHSBColor(float h, float s, float b, float a)`
    `IBrep` | `shear(double sxy, double syx, double syz, double szy, double szx, double sxz)` shear operation
    `IBrep` | `shear(IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)`
    `IBrep` | `shear(IVecI center, double sxy, double syx, double syz, double szy, double szx, double sxz)`
    `IBrep` | `shear(IVecI center, IDoubleI sxy, IDoubleI syx, IDoubleI syz, IDoubleI szy, IDoubleI szx, IDoubleI sxz)`
    `IBrep` | `shearXY(double sxy, double syx)`
    `IBrep` | `shearXY(IDoubleI sxy, IDoubleI syx)`
    `IBrep` | `shearXY(IVecI center, double sxy, double syx)`
    `IBrep` | `shearXY(IVecI center, IDoubleI sxy, IDoubleI syx)`
    `IBrep` | `shearYZ(double syz, double szy)`
    `IBrep` | `shearYZ(IDoubleI syz, IDoubleI szy)`
    `IBrep` | `shearYZ(IVecI center, double syz, double szy)`
    `IBrep` | `shearYZ(IVecI center, IDoubleI syz, IDoubleI szy)`
    `IBrep` | `shearZX(double szx, double sxz)`
    `IBrep` | `shearZX(IDoubleI szx, IDoubleI sxz)`
    `IBrep` | `shearZX(IVecI center, double szx, double sxz)`
    `IBrep` | `shearZX(IVecI center, IDoubleI szx, IDoubleI sxz)`
    `IBrep` | `show()`
    `IBrep` | `sub(double x, double y, double z)`
    `IBrep` | `sub(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBrep` | `sub(IVecI v)`
    `ISurfaceGeo` | `surface(int i)`
    `int` | `surfaceNum()`
    `ISurfaceGeo[]` | `surfaces()`
    `IBrep` | `transform(IMatrix3I mat)`
    `IBrep` | `transform(IMatrix4I mat)`
    `IBrep` | `transform(IVecI xvec, IVecI yvec, IVecI zvec)`
    `IBrep` | `transform(IVecI xvec, IVecI yvec, IVecI zvec, IVecI translate)`
    `IBrep` | `translate(double x, double y, double z)` translate() is alias of add()
    `IBrep` | `translate(IDoubleI x, IDoubleI y, IDoubleI z)`
    `IBrep` | `translate(IVecI v)`
    `IBrep` | `weight(double w)`
    `IBrep` | `weight(float w)`

    - ### Methods inherited from class igeo.IGeometry

      `setColor`

    - ### Methods inherited from class igeo.IObject

      `addDynamics, addUserData, addUserData, alpha, alphaInt, attr, attr, awtColor, blue, blueInt, brightness, castStringHashMap, clearDynamics, clearGraphics, clr, defaultAttribute, del, deletDynamics, deleteDynamics, deleteDynamics, deleteGraphic, dynamicsNum, getAWTColor, getColor, getDynamics, getGraphic, getGraphic, getParameter, graphicsNum, gray, grayInt, green, greenInt, grey, greyInt, hue, initGraphic, initObject, isVisible, layer, name, red, redInt, resetGraphic, saturation, server, setParameter, setTexture, syncColor, syncGraphic, syncVisibility, syncWeight, texture, updateGraphic, userData, userData, userData, userDataNum, visible, weight`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### surfaces

          public ISurfaceGeo[] surfaces

    - #### solid

          public boolean solid

      seams defines connection of surfaces (?)

  - ### Constructor Detail

    - #### IBrep

          public IBrep(IServerI s,
                       ISurfaceGeo[] srfs)

    - #### IBrep

          public IBrep(IServerI s,
                       ISurface[] srfs)

    - #### IBrep

          public IBrep(IServerI s,
                       ICurveI[] outlines)

    - #### IBrep

          public IBrep(IServerI s,
                       ICurveI[] outlines,
                       ICurveI[][] holes)

    - #### IBrep

          public IBrep(IServerI s,
                       IVecI[][] outlinePoints)

    - #### IBrep

          public IBrep(IServerI s,
                       IBrep brep)

    - #### IBrep

          public IBrep(ISurfaceGeo[] srfs)

    - #### IBrep

          public IBrep(IBrep brep)

    - #### IBrep

          public IBrep(ISurface[] srfs)

    - #### IBrep

          public IBrep(ICurveI[] outlines)

    - #### IBrep

          public IBrep(ICurveI[] outlines,
                       ICurveI[][] holes)

    - #### IBrep

          public IBrep(IVecI[][] outlinePoints)

  - ### Method Detail

    - #### initBrep

          public void initBrep(IServerI s)

    - #### initBrepWithSurfaceGeo

          public void initBrepWithSurfaceGeo(IServerI s,
                                             ISurfaceGeo[] srfs)

    - #### initBrepWithSurface

          public void initBrepWithSurface(IServerI s,
                                          ISurface[] srfs)

    - #### initBrepWithCurve

          public void initBrepWithCurve(IServerI s,
                                        ICurveI[] outlines,
                                        ICurveI[][] holes)

    - #### initBrepWithPoint

          public void initBrepWithPoint(IServerI s,
                                        IVecI[][] points)

    - #### checkDuplicatedPoints

          public void checkDuplicatedPoints()

    - #### createGraphic

          public IGraphicObject createGraphic(IGraphicMode m)

      Overrides:
        `createGraphic` in class `IObject`

    - #### surface

          public ISurfaceGeo surface(int i)

    - #### surfaceNum

          public int surfaceNum()

    - #### surfaces

          public ISurfaceGeo[] surfaces()

    - #### dup

          public IBrep dup()

      Description copied from class: `IObject`
      duplicate object
      Specified by:
        `dup` in interface `ITransformable`
      Overrides:
        `dup` in class `IGeometry`

    - #### center

          public IVecI center()

      calculate center by taking average of centers of all surfaces
      Specified by:
        `center` in class `IGeometry`

    - #### isValid

          public boolean isValid()

      checking parameters validity.
      Overrides:
        `isValid` in class `IObject`

    - #### name

          public IBrep name(java.lang.String nm)

      Overrides:
        `name` in class `IObject`

    - #### layer

          public IBrep layer(ILayer l)

      Description copied from class: `IGeometry`
      Set layer by ILayer object
      Overrides:
        `layer` in class `IGeometry`

    - #### layer

          public IBrep layer(java.lang.String l)

      Description copied from class: `IGeometry`
      Set layer by layer name. If the layer specified by the name is not existing in the server, a new layer is automatically created in the server
      Overrides:
        `layer` in class `IGeometry`

    - #### attr

          public IBrep attr(IAttribute at)

      Description copied from class: `IObject`
      set attributes
      Overrides:
        `attr` in class `IGeometry`

    - #### hide

          public IBrep hide()

      Overrides:
        `hide` in class `IGeometry`

    - #### show

          public IBrep show()

      Overrides:
        `show` in class `IGeometry`

    - #### clr

          public IBrep clr(IColor c)

      Description copied from class: `IObject`
      to set an object color
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(IColor c,
                           int alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(IColor c,
                           float alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(IColor c,
                           double alpha)

      Description copied from class: `IObject`
      to set color, with alpha value overwritten
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(IObject o)

      Description copied from class: `IObject`
      to set the same color with the object
      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(java.awt.Color c)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(java.awt.Color c,
                           int alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(java.awt.Color c,
                           float alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(java.awt.Color c,
                           double alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(int gray)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(float fgray)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(double dgray)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(int gray,
                           int alpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(float fgray,
                           float falpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(double dgray,
                           double dalpha)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(int r,
                           int g,
                           int b)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(float fr,
                           float fg,
                           float fb)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(double dr,
                           double dg,
                           double db)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(int r,
                           int g,
                           int b,
                           int a)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(float fr,
                           float fg,
                           float fb,
                           float fa)

      Overrides:
        `clr` in class `IGeometry`

    - #### clr

          public IBrep clr(double dr,
                           double dg,
                           double db,
                           double da)

      Overrides:
        `clr` in class `IGeometry`

    - #### hsb

          public IBrep hsb(float h,
                           float s,
                           float b,
                           float a)

      Overrides:
        `hsb` in class `IGeometry`

    - #### hsb

          public IBrep hsb(double h,
                           double s,
                           double b,
                           double a)

      Overrides:
        `hsb` in class `IGeometry`

    - #### hsb

          public IBrep hsb(float h,
                           float s,
                           float b)

      Overrides:
        `hsb` in class `IGeometry`

    - #### hsb

          public IBrep hsb(double h,
                           double s,
                           double b)

      Overrides:
        `hsb` in class `IGeometry`

    - #### setColor

          public IBrep setColor(IColor c)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IBrep setColor(IColor c,
                                int alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IBrep setColor(IColor c,
                                float alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IBrep setColor(IColor c,
                                double alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IBrep setColor(java.awt.Color c)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(java.awt.Color c,
                                int alpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(java.awt.Color c,
                                float alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IBrep setColor(java.awt.Color c,
                                double alpha)

      Overrides:
        `setColor` in class `IObject`

    - #### setColor

          public IBrep setColor(int gray)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(float fgray)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(double dgray)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(int gray,
                                int alpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(float fgray,
                                int falpha)

    - #### setColor

          public IBrep setColor(double dgray,
                                double dalpha)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(int r,
                                int g,
                                int b)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(float fr,
                                float fg,
                                float fb)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(double dr,
                                double dg,
                                double db)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(int r,
                                int g,
                                int b,
                                int a)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(float fr,
                                float fg,
                                float fb,
                                float fa)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setColor

          public IBrep setColor(double dr,
                                double dg,
                                double db,
                                double da)

      Overrides:
        `setColor` in class `IGeometry`

    - #### setHSBColor

          public IBrep setHSBColor(float h,
                                   float s,
                                   float b,
                                   float a)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### setHSBColor

          public IBrep setHSBColor(double h,
                                   double s,
                                   double b,
                                   double a)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### setHSBColor

          public IBrep setHSBColor(float h,
                                   float s,
                                   float b)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### setHSBColor

          public IBrep setHSBColor(double h,
                                   double s,
                                   double b)

      Overrides:
        `setHSBColor` in class `IGeometry`

    - #### weight

          public IBrep weight(double w)

      Overrides:
        `weight` in class `IGeometry`

    - #### weight

          public IBrep weight(float w)

      Overrides:
        `weight` in class `IGeometry`

    - #### add

          public IBrep add(double x,
                           double y,
                           double z)

      implementation of ITransformable interface
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IBrep add(IDoubleI x,
                           IDoubleI y,
                           IDoubleI z)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IBrep add(IVecI v)

      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### sub

          public IBrep sub(double x,
                           double y,
                           double z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in class `IGeometry`

    - #### sub

          public IBrep sub(IDoubleI x,
                           IDoubleI y,
                           IDoubleI z)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in class `IGeometry`

    - #### sub

          public IBrep sub(IVecI v)

      Specified by:
        `sub` in interface `ITransformable`
      Specified by:
        `sub` in class `IGeometry`

    - #### mul

          public IBrep mul(IDoubleI v)

      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in class `IGeometry`

    - #### mul

          public IBrep mul(double v)

      Specified by:
        `mul` in interface `ITransformable`
      Specified by:
        `mul` in class `IGeometry`

    - #### div

          public IBrep div(IDoubleI v)

      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in class `IGeometry`

    - #### div

          public IBrep div(double v)

      Specified by:
        `div` in interface `ITransformable`
      Specified by:
        `div` in class `IGeometry`

    - #### neg

          public IBrep neg()

      Specified by:
        `neg` in interface `ITransformable`
      Specified by:
        `neg` in class `IGeometry`

    - #### flip

          public IBrep flip()

      alias of neg
      Specified by:
        `flip` in interface `ITransformable`
      Specified by:
        `flip` in class `IGeometry`

    - #### add

          public IBrep add(IVecI v,
                           double f)

      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IBrep add(IVecI v,
                           IDoubleI f)

      Description copied from class: `IGeometry`
      scale add
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IBrep add(double f,
                           IVecI v)

      scale add alias
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### add

          public IBrep add(IDoubleI f,
                           IVecI v)

      Description copied from class: `IGeometry`
      scale add alias
      Specified by:
        `add` in interface `ITransformable`
      Specified by:
        `add` in class `IGeometry`

    - #### rot

          public IBrep rot(IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation around z-axis and origin
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IBrep rot(double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IBrep rot(IVecI axis,
                           IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation around axis vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IBrep rot(IVecI axis,
                           double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IBrep rot(IVecI center,
                           IVecI axis,
                           IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation around axis vector and center
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IBrep rot(IVecI center,
                           IVecI axis,
                           double angle)

      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IBrep rot(IVecI axis,
                           IVecI destDir)

      rotate to destination direction vector
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot

          public IBrep rot(IVecI center,
                           IVecI axis,
                           IVecI destPt)

      rotate to destination point location
      Specified by:
        `rot` in interface `ITransformable`
      Specified by:
        `rot` in class `IGeometry`

    - #### rot2

          public IBrep rot2(IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation on xy-plane around origin; same with rot(IDoubleI)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IBrep rot2(double angle)

      Description copied from class: `IGeometry`
      rotation on xy-plane around origin; same with rot(double)
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IBrep rot2(IVecI center,
                            IDoubleI angle)

      Description copied from class: `IGeometry`
      rotation on xy-plane around center
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IBrep rot2(IVecI center,
                            double angle)

      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IBrep rot2(IVecI destDir)

      rotation on xy-plane to destination direction vector
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### rot2

          public IBrep rot2(IVecI center,
                            IVecI destPt)

      rotation on xy-plane to destination point location
      Specified by:
        `rot2` in interface `ITransformable`
      Specified by:
        `rot2` in class `IGeometry`

    - #### scale

          public IBrep scale(IDoubleI f)

      alias of mul
      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale

          public IBrep scale(double f)

      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale

          public IBrep scale(IVecI center,
                             IDoubleI f)

      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale

          public IBrep scale(IVecI center,
                             double f)

      Specified by:
        `scale` in interface `ITransformable`
      Specified by:
        `scale` in class `IGeometry`

    - #### scale1d

          public IBrep scale1d(IVecI axis,
                               double f)

      scale only in 1 direction
      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### scale1d

          public IBrep scale1d(IVecI axis,
                               IDoubleI f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### scale1d

          public IBrep scale1d(IVecI center,
                               IVecI axis,
                               double f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### scale1d

          public IBrep scale1d(IVecI center,
                               IVecI axis,
                               IDoubleI f)

      Specified by:
        `scale1d` in interface `ITransformable`
      Specified by:
        `scale1d` in class `IGeometry`

    - #### ref

          public IBrep ref(IVecI planeDir)

      reflect(mirror) 3 dimensionally to the other side of the plane
      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in class `IGeometry`

    - #### ref

          public IBrep ref(IVecI center,
                           IVecI planeDir)

      Specified by:
        `ref` in interface `ITransformable`
      Specified by:
        `ref` in class `IGeometry`

    - #### mirror

          public IBrep mirror(IVecI planeDir)

      mirror is alias of ref
      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in class `IGeometry`

    - #### mirror

          public IBrep mirror(IVecI center,
                              IVecI planeDir)

      Specified by:
        `mirror` in interface `ITransformable`
      Specified by:
        `mirror` in class `IGeometry`

    - #### shear

          public IBrep shear(double sxy,
                             double syx,
                             double syz,
                             double szy,
                             double szx,
                             double sxz)

      shear operation
      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in class `IGeometry`

    - #### shear

          public IBrep shear(IDoubleI sxy,
                             IDoubleI syx,
                             IDoubleI syz,
                             IDoubleI szy,
                             IDoubleI szx,
                             IDoubleI sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in class `IGeometry`

    - #### shear

          public IBrep shear(IVecI center,
                             double sxy,
                             double syx,
                             double syz,
                             double szy,
                             double szx,
                             double sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in class `IGeometry`

    - #### shear

          public IBrep shear(IVecI center,
                             IDoubleI sxy,
                             IDoubleI syx,
                             IDoubleI syz,
                             IDoubleI szy,
                             IDoubleI szx,
                             IDoubleI sxz)

      Specified by:
        `shear` in interface `ITransformable`
      Specified by:
        `shear` in class `IGeometry`

    - #### shearXY

          public IBrep shearXY(double sxy,
                               double syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearXY

          public IBrep shearXY(IDoubleI sxy,
                               IDoubleI syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearXY

          public IBrep shearXY(IVecI center,
                               double sxy,
                               double syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearXY

          public IBrep shearXY(IVecI center,
                               IDoubleI sxy,
                               IDoubleI syx)

      Specified by:
        `shearXY` in interface `ITransformable`
      Specified by:
        `shearXY` in class `IGeometry`

    - #### shearYZ

          public IBrep shearYZ(double syz,
                               double szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearYZ

          public IBrep shearYZ(IDoubleI syz,
                               IDoubleI szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearYZ

          public IBrep shearYZ(IVecI center,
                               double syz,
                               double szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearYZ

          public IBrep shearYZ(IVecI center,
                               IDoubleI syz,
                               IDoubleI szy)

      Specified by:
        `shearYZ` in interface `ITransformable`
      Specified by:
        `shearYZ` in class `IGeometry`

    - #### shearZX

          public IBrep shearZX(double szx,
                               double sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### shearZX

          public IBrep shearZX(IDoubleI szx,
                               IDoubleI sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### shearZX

          public IBrep shearZX(IVecI center,
                               double szx,
                               double sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### shearZX

          public IBrep shearZX(IVecI center,
                               IDoubleI szx,
                               IDoubleI sxz)

      Specified by:
        `shearZX` in interface `ITransformable`
      Specified by:
        `shearZX` in class `IGeometry`

    - #### mv

          public IBrep mv(double x,
                          double y,
                          double z)

      mv() is alias of add()
      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in class `IGeometry`

    - #### mv

          public IBrep mv(IDoubleI x,
                          IDoubleI y,
                          IDoubleI z)

      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in class `IGeometry`

    - #### mv

          public IBrep mv(IVecI v)

      Specified by:
        `mv` in interface `ITransformable`
      Specified by:
        `mv` in class `IGeometry`

    - #### cp

          public IBrep cp()

      cp() is alias of dup()
      Specified by:
        `cp` in interface `ITransformable`
      Overrides:
        `cp` in class `IGeometry`

    - #### cp

          public IBrep cp(double x,
                          double y,
                          double z)

      cp() is alias of dup().add()
      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in class `IGeometry`

    - #### cp

          public IBrep cp(IDoubleI x,
                          IDoubleI y,
                          IDoubleI z)

      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in class `IGeometry`

    - #### cp

          public IBrep cp(IVecI v)

      Specified by:
        `cp` in interface `ITransformable`
      Specified by:
        `cp` in class `IGeometry`

    - #### translate

          public IBrep translate(double x,
                                 double y,
                                 double z)

      translate() is alias of add()
      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in class `IGeometry`

    - #### translate

          public IBrep translate(IDoubleI x,
                                 IDoubleI y,
                                 IDoubleI z)

      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in class `IGeometry`

    - #### translate

          public IBrep translate(IVecI v)

      Specified by:
        `translate` in interface `ITransformable`
      Specified by:
        `translate` in class `IGeometry`

    - #### transform

          public IBrep transform(IMatrix3I mat)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in class `IGeometry`

    - #### transform

          public IBrep transform(IMatrix4I mat)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in class `IGeometry`

    - #### transform

          public IBrep transform(IVecI xvec,
                                 IVecI yvec,
                                 IVecI zvec)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in class `IGeometry`

    - #### transform

          public IBrep transform(IVecI xvec,
                                 IVecI yvec,
                                 IVecI zvec,
                                 IVecI translate)

      Specified by:
        `transform` in interface `ITransformable`
      Specified by:
        `transform` in class `IGeometry`